var openSB = (function () {

	//"use strict";

	function loadResource(url, type) {
		var head = document.getElementsByTagName('head').item(0),
			res = null;
		type = (!type) ? '' : type;
		if (type.toLowerCase() == 'css') {
			res = document.createElement('link'); 
			res.type = 'text/css';
			res.href = url;
			res.rel = 'stylesheet';
		} else {
			res = document.createElement('script');
			res.src = url;
			res.type = 'text/javascript';
		}
		head.appendChild(res);
	}

	var protocol = ('https:' == document.location.protocol ? 'https:' : 'http:') 
	
	loadResource(protocol + '//www.simplebooking.it/scripts/cwcalendar/calendar.js');
	loadResource(protocol + '//www.simplebooking.it/scripts/cwcalendar/cwcalendar.css', 'css');

	var Localizations = {
		SundayFirst : {
			EN : true
	},
		FullMonth : {
					EN : ['January','February','March','April','May','June','July','August','September','October','November','December']
		},
	SmallMonth : {
				EN : ['Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec']
	},
	FullDay : {
				EN : ['Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday']
	},
	SmallDay : {
				EN : ['Sun','Mon','Tue','Wed','Thu','Fri','Sat']
	},
	MealPlan : {
				EN : ['Show any available','Breakfast Included','Half board','Full board','Room Only','All Inclusive']
	},
	Labels : {
		CheckinDate : { 
			CA:"Data d\'arribada: ",
			CS:"Datum příjezdu: ",
			DA:"Indtjekningsdato: ",
			DE:"Anreisedatum: ",
			EL:"Ημερομηνία άφιξης: ",
			EN:"Arrival Date: ",
			ES:"Fecha de llegada: ",
			FR:"Date d\'arrivée: ",
			HR:"Datum dolaska: ",
			HU:"Érkezés dátuma: ",
			ID:"Tanggal Kedatangan: ",
			IT:"Data Arrivo: ",
			JA:"到着日: ",
			KO:"도착 날짜: ",
			NL:"Aankomstdatum: ",
			PL:"Data przyjazdu: ",
			PT:"Data de chegada: ",
			RO:"Data Sosirii: ",
			RU:"Дата приезда: ",
			TR:"Giriş Günü: ",
			ZH:"到达日期: " 
		},
		CheckoutDate : { 
			CA:"Data de sortida: ",
			CS:"Datum odjezdu: ",
			DA:"Udtjekningsdato: ",
			DE:"Abreisedatum: ",
			EL:"Ημερομηνία αναχώρησης: ",
			EN:"Departure Date: ",
			ES:"Fecha de salida: ",
			FR:"Date de départ: ",
			HR:"Datum odlaska: ",
			HU:"Távozás dátuma: ",
			ID:"Tanggal Keberangkatan: ",
			IT:"Data Partenza: ",
			JA:"出発日: ",
			KO:"출발 날짜: ",
			NL:"Vertrekdatum: ",
			PL:"Data wyjazdu: ",
			PT:"Data de partida: ",
			RO:"Data Plecării: ",
			RU:"Дата отъезда: ",
			TR:"Çıkış Günü: ",
			ZH:"离开日期: " 
		},
		NumNights : { 
			CA:"Nits: ",
			CS:"Nocí: ",
			DA:"Overnatninger: ",
			DE:"Nächte: ",
			EL:"Νύχτες: ",
			EN:"Nights: ",
			ES:"Noches: ",
			FR:"Nuits: ",
			HR:"Noći: ",
			HU:"Éjszaka száma: ",
			ID:"Malam: ",
			IT:"Notti: ",
			JA:"泊: ",
			KO:"박: ",
			NL:"Nachten: ",
			PL:"Noce: ",
			PT:"Noites: ",
			RO:"Nopţi: ",
			RU:"Hочей: ",
			TR:"Gece Sayısı: ",
			ZH:"夜晚: " 
		},
		NumRooms : { 
			CA:"Habitacions: ",
			CS:"Pokoje: ",
			DA:"Værelser: ",
			DE:"Zimmer: ",
			EL:"Δωμάτια: ",
			EN:"Rooms: ",
			ES:"Habitaciónes: ",
			FR:"Chambres: ",
			HR:"Sobe: ",
			HU:"Szobák száma: ",
			ID:"Kamar: ",
			IT:"Camere: ",
			JA:"部屋: ",
			KO:"방: ",
			NL:"Kamers: ",
			PL:"Pokoje: ",
			PT:"Quartos: ",
			RO:"Camere: ",
			RU:"Номера: ",
			TR:"Oda: ",
			ZH:"房间: " 
		},
		NumPersons : { 
			CA:"Persones: ",
			CS:"Osoby: ",
			DA:"Personer: ",
			DE:"Personen: ",
			EL:"Άτομα: ",
			EN:"Persons: ",
			ES:"Personas: ",
			FR:"Personnes: ",
			HR:"Osobe: ",
			HU:"Vendégek száma: ",
			ID:"Orang: ",
			IT:"Persone: ",
			JA:"人: ",
			KO:"인원수: ",
			NL:"Personen: ",
			PL:"Osoby: ",
			PT:"Pessoas: ",
			RO:"Persoane: ",
			RU:"Гости: ",
			TR:"Kişi: ",
			ZH:"人数: " 
		},
		NumAdults : { 
			CA:"Adults: ",
			CS:"Dospělí: ",
			DA:"Voksne: ",
			DE:"Erw.: ",
			EL:"Ενήλικες: ",
			EN:"Adults: ",
			ES:"Adultos: ",
			FR:"Adultes: ",
			HR:"Odrasli: ",
			HU:"Felnőttek: ",
			ID:"Dewasa: ",
			IT:"Adulti: ",
			JA:"大人: ",
			KO:"성인: ",
			NL:"Volwassenen: ",
			PL:"Dorośli: ",
			PT:"Adultos: ",
			RO:"Adulţi: ",
			RU:"Взрослые: ",
			TR:"Yetişkinler: ",
			ZH:"成人: " 
		},
		NumKids : { 
			CA:"Nens: ",
			CS:"Děti: ",
			DA:"Børn: ",
			DE:"Kinder: ",
			EL:"Παιδιά: ",
			EN:"Kids: ",
			ES:"Niños: ",
			FR:"Enfants: ",
			HR:"Djeca: ",
			HU:"Gyerekek: ",
			ID:"Anak-anak: ",
			IT:"Bambini: ",
			JA:"子供: ",
			KO:"아동: ",
			NL:"Kinderen: ",
			PL:"Dzieci: ",
			PT:"Crianças: ",
			RO:"Copii: ",
			RU:"Дети: ",
			TR:"Çocuklar: ",
			ZH:"孩子: " 
		},
		KidAge : { 
			CA:"Edat: ",
			CS:"Věk: ",
			DA:"Alder: ",
			DE:"Alter: ",
			EL:"Ηλικία: ",
			EN:"Age: ",
			ES:"Edad: ",
			FR:"Âge: ",
			HR:"Godina: ",
			HU:"Életkor: ",
			ID:"Usia: ",
			IT:"Età: ",
			JA:"年齢: ",
			KO:"나이: ",
			NL:"Leeftijd: ",
			PL:"Wiek: ",
			PT:"Idade: ",
			RO:"Vârsta: ",
			RU:"Возраст: ",
			TR:"Yaş: ",
			ZH:"年龄: " 
		},
		RoomAllocation : { 
			CA:"Hostes per a habitació #",
			CS:"Hostů v pokoji #",
			DA:"Gæster i værelse #",
			DE:"Gäste Zimmer #",
			EL:"Επισκέπτες για το δωμάτιο",
			EN:"Guests for room #",
			ES:"Huéspedes por habitación #",
			FR:"Hôtes chambre #",
			HR:"Gostiju po sobi",
			HU:"Vendégek száma szobánként",
			ID:"Tamu untuk kamar #",
			IT:"Ospiti camera #",
			JA:"＃番のお部屋",
			KO:"방 #       의 게스트",
			NL:"Gasten voor kamer #",
			PL:"Liczba osób w pokoju #",
			PT:"Hóspedes por quarto #",
			RO:"Ocupanţi cameră #",
			RU:"Проживающие в номере #",
			TR:"Oda için misafirler",
			ZH:"房客 #" 
		},
		MealPlan : { 
			CA:"Règim de pensió: ",
			CS:"Stravování: ",
			DA:"Forplejning: ",
			DE:"Art der Bewirtung: ",
			EL:"Πλάνο φαγητού: ",
			EN:"Meal plan: ",
			ES:"Tratamiento: ",
			FR:"Traîtement: ",
			HR:"Plan prehrane: ",
			HU:"Étkezés: ",
			ID:"Paket makan: ",
			IT:"Trattamento: ",
			JA:"お食事プラン: ",
			KO:"식사: ",
			NL:"Inbegrepen maaltijden: ",
			PL:"Wyżywienie: ",
			PT:"Tipo de estadia: ",
			RO:"Regim de masă: ",
			RU:"Питание: ",
			TR:"Yemek Planı: ",
			ZH:"餐饮安排: " 
		},
		PromoCode : { 
			CA:"Codi promocional: ",
			CS:"Promo kód: ",
			DA:"Kampagnekode: ",
			DE:"Promotionscode: ",
			EL:"Κωδικός προώθησης: ",
			EN:"Promo code: ",
			ES:"Código promocional: ",
			FR:"Code promotionnel: ",
			HR:"Promo kod: ",
			HU:"Promóciós kód: ",
			ID:"Kode promo: ",
			IT:"Codice promo: ",
			JA:"プロモコード: ",
			KO:"프로모 코드: ",
			NL:"Kortingscode: ",
			PL:"Kod promocyjny: ",
			PT:"Código promocional: ",
			RO:"Cod promo: ",
			RU:"Промокод: ",
			TR:"Promosyon Kodu: ",
			ZH:"促销代码: " 
		},
		CheckAvailability : { 
			CA:"Comproveu disponibilitat",
			CS:"Ověření volné kapacity",
			DA:"Undersøg ledighed",
			DE:"Verfügbarkeit Prüfen",
			EL:"Έλεγχος διαθεσιμότητας",
			EN:"Check Availability",
			ES:"Comprobar Disponibilidad",
			FR:"Vérifier la Disponibilité",
			HR:"Provjeri raspoloživost",
			HU:"Szobák és árak megtekintése",
			ID:"Periksa Ketersediaan",
			IT:"Verifica Disponibilità",
			JA:"有効性を確認してください",
			KO:"가능 여부 확인",
			NL:"Controleer beschikbaarheid",
			PL:"Sprawdź dyspozycyjność",
			PT:"Verificar Disponibilidade",
			RO:"Verificare Disponibilitate",
			RU:"Проверить доступность",
			TR:"Müsaitliği Kontrol Et",
			ZH:"检查可用性" 
		},
		ModCancReservation : { 
			CA:"modifiqueu/cancel·leu una reserva existent",
			CS:"zrušit/změnit rezervaci",
			DA:"ændre/annullere en eksisterende reservation",
			DE:"Reservierung ändern/löschen",
			EL:"τροποποίηση/ακύρωση μιας υπάρχουσας κράτησης",
			EN:"modify/cancel an existing reservation",
			ES:"modificar / cancelar una reserva ya existente",
			FR:"modification/annulation de réservations",
			HR:"promijeni/otkaži postojeću rezervaciju",
			HU:"Meglévő foglalás módosítása/törlése",
			ID:"modifikasi/batalkan reservasi yang ada",
			IT:"modifica/cancella una prenotazione",
			JA:"ただいまの予約の変更/キャンセル",
			KO:"기존 예약 변경/취소",
			NL:"wijzig/annuleer een bestaande reservering",
			PL:"zmień/anuluj rezerwację",
			PT:"modificar / cancelar uma reserva existente",
			RO:"modifică/anulează o rezervare",
			RU:"Изменить/аннулировать бронь",
			TR:"Mevcut rezervasyonu düzenle/iptal et",
			ZH:"修改/取消已有预约" 
		},
		OpenSbPromoCode : {
			CA:"Accés empreses",
			CS:"Vstup pro partnery",
			DA:"Virksomhedsadgang",
			DE:"Corporate access",
			EL:"Εταιρική πρόσβαση",
			EN:"Corporate access",
			ES:"Corporate access",
			FR:"Corporate access",
			HR:"Korporativni pristup",
			HU:"Vállalati hozzáférés",
			ID:"Akses perusahaan",
			IT:"Accesso convenzionato",
			JA:"法人利用",
			KO:"회사 접속 코드",
			NL:"Zakelijke toegang",
			PL:"Dostęp zarezerwowany",
			PT:"Corporate access",
			RO:"Acces firme",
			RU:"Вход для партнёров",
			TR:"Kurumsal erişim",
			ZH:"访问企业" 
		},
		InfoSSL : {
			CA:"Tota la informació està protegida per criptografia de seguretat SSL",
			CS:"Informace chráněné  certifikátem SSL 128 bit",
			DA:"Alle oplysninger er beskyttet med stærk SSL-kryptering",
			DE:"All information protected with SSL strong encryption",
			EL:"Όλες οι πληροφορίες προστατεύονται από ισχυρή αποδικοποίηση SSL",
			EN:"All information protected with SSL strong encryption",
			ES:"All information protected with SSL strong encryption",
			FR:"All information protected with SSL strong encryption",
			HR:"Sve informacije su zaštićene jakom SSL enkripcijom",
			HU:"Minden adat szigorúan védett és titkosított  SSL tanúsítvánnyal.",
			ID:"Semua informasi dilindungi dengan enkripsi kuat SSL",
			IT:"Informazioni protette con certificato SSL 128 bit",
			JA:"全ての情報はSSLの強力な暗号によって守られています",
			KO:"모든 정보는 SSL 의 암호화로 강력하게 보호됩니다.",
			NL:"Alle gegevens worden beschermd via sterke SSL-encryptie",
			PL:"Informacje chronione certyfikatem SSL 128 bit",
			PT:"All information protected with SSL strong encryption",
			RO:"Informaţii protejate cu certificat SSL 128 bit",
			RU:"Информация, защищенная сертификатом SSL 128 bit",
			TR:"Tüm bilgiler güçlü SSL kriptolama ile korunmaktadır",
			ZH:"所有信息经过SSL进行强加密保护。" 
		},
		TravelWithKids : {
			CA:"Viatgeu amb nens?",
			CS:"Cestujete s dětmi?",
			DA:"Rejser du med børn?",
			DE:"Travel with kids?",
			EL:"Ταξιδεύετε με παιδιά;",
			EN:"Travel with kids?",
			ES:"Travel with kids?",
			FR:"Travel with kids?",
			HR:"Putujete s djecom?",
			HU:"Utazás gyerekekkel?",
			ID:"Perjalanan dengan anak-anak?",
			IT:"Viaggi con bambini?",
			JA:"お子様連れですか？",
			KO:"자녀와 함께 여행하세요?",
			NL:"Reist u met kinderen?",
			PL:"Podróżujecie z dziećmi?",
			PT:"Travel with kids?",
			RO:"Călătoriţi cu copiii?",
			RU:"Вы путешествуете с детьми?",
			TR:"Çocukla mı seyehat ediyorsunuz?",
			ZH:"是否带孩子旅行？" 
		},
		SelectProperty : {
			CA:"Propietat:",
			CS:"Hotel:",
			DA:"Ejendom:",
			DE:"Eigenschaft:",
			EL:"Ξενοδοχείο:",
			EN:"Property:",
			ES:"Propiedad:",
			FR:"Propriété:",
			HR:"Vlasništvo",
			HU:"Szállás:",
			ID:"Properti:",
			IT:"Struttura:",
			JA:"資産",
			KO:"호텔",
			NL:"Accommodatie:",
			PL:"Property:",
			PT:"Propriedade:",
			RO:"Property:",
			RU:"Отель:",
			TR:"Otel:",
			ZH:"属性：" 
		}
	},
	Errors : {
		KidAgeRequired : { 
			CA:"Seleccioneu l\'edat de cada nen.",
			CS:"Prosím zvolte věk každého dítěte.",
			DA:"Vælg barnets alder.",
			DE:"Bitte wählen Sie das Alter für jedes Kind.",
			EL:"Παρακαλώ, επιλέξτε την ηλικία για κάθε παιδί",
			EN:"Please select the age for each kid.",
			ES:"Por favor seleccione la edad de cada niño.",
			FR:"S\'il vous plaît sélectionnez l\'âge pour chaque enfant.",
			HR:"Molimo, navedite dob djece",
			HU:"Kérem válassza ki a gyerekek életkorát.",
			ID:"Silakan pilih usia untuk setiap anak-anak.",
			IT:"Si prega di selezionare un\'età per tutti i bambini presenti.",
			JA:"お子様の年齢を入力してください",
			KO:"모든 자녀의 나이를 선택해 주세요.",
			NL:"De leeftijd voor elk kind selecteren.",
			PL:"Proszę podać wiek wszystkich dzieci.",
			PT:"Por favor, selecione a idade de cada criança.",
			RO:"Vă rugăm selectaţi o vârstă pentru toţi copiii prezenţi.",
			RU:"Укажите возраст каждого ребенка.",
			TR:"Lütfen her bir çocuğun yaşını giriniz",
			ZH:"请为每个孩子选择年龄。" 
		}
	}
};

var SBParameters = window.SBParameters || { };

var sbSearch = {
	ScriptBound : false,
	ScriptLoaded : false,
	FormChecked : false,
	UseSingleDateField : false,
	CalculateNights : false,
	UseKidsAge : false,
	WindowForm : null,
	DivCalendar : null,
	ConfigErrors : [],
	Parameters : {
		AutoLoad : true,
		MultiProperty : false,
		HotelId : 3473,
		GuidProperty : '36408c2a-cca7-485d-a54e-8110480171e7',
		CodLang : 'EN',
		Currency: 'USD',
		Use12PersonLimit : false,
		OnlyMultiplies : false,
		MinStay : 1,
		ReleaseDays : 0,
		CheckInDays : [0,1,2,3,4,5,6],
		AvailableMealPlans : [1],
		UseBookingInPage : false,
		UseNewBooking : true,
		UseResponsive : true,
		UseGoogleAnalyticsIntegration : false,
		GAPageTrackerName : 'pageTracker',
		OpenInNewWindow : false,

		CustomCalendarCssUrl: '',

		Checkin : null,
		Checkout : null,

		TotRoomsHotel : 17,

		DefaultPersons: 2,

		MaxRooms : 4,
		MaxAdults : 6,
		MaxKids : 4,
		MinKidsAge : 2,
		MaxKidsAge : 12,

		PlaceHolderId : '',
		SBContainerId : '',
		AbsolutePositionOnInit : false,

		AfterInitCallBack : null,

		HomesiteUrl : '',
		TabletAgents : ['ipad','android(?!.*mobile)'],
		MobileAgents : ['mobile', 'iphone', 'ipad', 'ipod', 'nokia', 'htc', 'samsung', 'symbian', 'blackberry', 'opera mobi', 'opera mini', 'windows ce', 'windows phone', 'android', 'palm', 'portable'],
		ExcludeMobileSiteForTablet : true,
		UseMobile : function() {
			var agent = navigator.userAgent.toLowerCase();
	
			if(this._checkAgent(agent, this.TabletAgents)) {
				return (this.ExcludeMobileSiteForTablet) ? false : true;
			}

			return (this._checkAgent(agent, this.MobileAgents)) ? true : false;
		},
		_checkAgent : function(agent, userAgentsArray) {
			for (var i = 0; i < userAgentsArray.length; i++) {
				var regex = new RegExp(userAgentsArray[i], 'i');
				if (regex.test(agent)) {
					return true;
				}
			}
			return false;
		},
	
		SearchFormId : 'frm',
		GuidId : 'GUID',
		SearchButtonId : 'btnSearch',
		StartDayId : 'ddlArrivoGiorno',
		StartMonthId : 'ddlArrivoMese',
		StartYearId : 'ddlArrivoAnno',
		EndDayId : 'ddlPartenzaGiorno',
		EndMonthId : 'ddlPartenzaMese',
		EndYearId : 'ddlPartenzaAnno',
		NumNightsId : 'ddlNotti',
		NumPersonsId : 'ddlPersone',
		NumKidsId : 'ddlBambini',
		NumRoomsId : 'ddlCamere',
		MealPlansId : 'ddlTrattamento',
		PromoCodeId : 'code',
		StartDayLabelId : 'dvGiornoArrivo',
		EndDayLabelId : 'dvGiornoPartenza',

		StartFullDateId : 'txtArrivalDate',
		EndFullDateId : 'txtDepartureDate',
		HiddenStartDateId : 'hdnDataArrivo',
		HiddenEndDateId : 'hdnDataPartenza',
		CompleteStartDateId : 'hdnDataArrivo', //For compatibility
		CompleteEndDateId : 'hdnDataPartenza', //For compatibility

		CheckinLabelId : 'label-checkin',
		CheckoutLabelId : 'label-checkout',
		NumNightsLabelId : 'label-numnight',
		NumRoomsLabelId : 'label-numrooms',
		NumPersonsLabelId : 'label-numpersons',
		NumPersonsRoomIndexLabelId : 'label-numpersons{{ROOM_INDEX}}',
		NumAdultsLabelId : 'label-numadults{{ROOM_INDEX}}',
		NumKidsLabelId : 'label-numkids{{ROOM_INDEX}}',
		KidAgeLabelId : 'label-kidage{{ROOM_INDEX}}',
		RoomAllocationLabelId : 'label-roomallocation{{ROOM_INDEX}}',
		MealPlanLabelId : 'label-mealplan',
		PromoCodeLabelId : 'label-promocode',
		ModCancReservationLabelId : 'label-modcancreservation',
		OpenSbPromoCodeLabelId : 'label-linkpromo',
		InfoSslLabelId : 'label-info-ssl',
		TravelWithKidsLabelId : 'label-travelwithkids',
		SelectPropertyLabelId : 'label-selectproperty',

		DaysLengthType : 1,
		MonthLengthType : 0,
		YearLengthType : 1,
		Addresses : new function() {
			this.HttpHost = 'https://www.simplebooking.it';
			this.BookUrl = this.HttpHost + '/booking.aspx';
			this.PageBookUrl = this.HttpHost + '/pagebooking.aspx';
			this.NewBookingUrl = this.HttpHost + '/ibe/hotelbooking/search';
			this.CancUrl = this.HttpHost + '/booking.aspx';
			this.CalendarUrl = this.HttpHost + '/Inclusioni/Popup/calendario_javascript.aspx';
		},
		KidsAgeIds : {
			RoomAdultsKidsBlockId : 'dvCam{{ROOM_INDEX}}',
			RoomAdultFieldId : 'Cam{{ROOM_INDEX}}Adulti',
			RoomKidFieldId : 'Cam{{ROOM_INDEX}}Bambini',
			RoomKidAgeBlockId : 'dvEta{{ROOM_INDEX}}{{KID_INDEX}}',
			RoomKidAgeFieldId : 'Cam{{ROOM_INDEX}}Fascia{{KID_INDEX}}'
		}
	},
	QueryString : {
		StartDateDay : null,
		StartDateMonth : null,
		StartDateYear : null,
		EndDateDay : null,
		EndDateMonth : null,
		EndDateYear : null,
		StartDateIsValid : false,
		EndDateIsValid : false,
		NumRooms : null,
		NumPersons : null,
		NumKids : null,
		NumNights : null,
		MealPlans : null,
		PromoCode : null,
		Initialize : function() {
			this.StartDateDay = sbSearch.ParseInt(sbSearch.GetQS('ddlArrivoGiorno'));
			this.StartDateMonth = sbSearch.ParseInt(sbSearch.GetQS('ddlArrivoMese'));
			this.StartDateYear = sbSearch.ParseInt(sbSearch.GetQS('ddlArrivoAnno'));
			this.EndDateDay = sbSearch.ParseInt(sbSearch.GetQS('ddlPartenzaGiorno'));
			this.EndDateMonth = sbSearch.ParseInt(sbSearch.GetQS('ddlPartenzaMese'));
			this.EndDateYear = sbSearch.ParseInt(sbSearch.GetQS('ddlPartenzaAnno'));
			this.StartDateIsValid = function() {
				try {
					var chkDate = new Date(sbSearch.QueryString.StartDateYear, (sbSearch.QueryString.StartDateMonth - 1), sbSearch.QueryString.StartDateDay);
					return (chkDate.getFullYear() == sbSearch.QueryString.StartDateYear) && ((chkDate.getMonth() + 1 )== sbSearch.QueryString.StartDateMonth) && (chkDate.getDate() == sbSearch.QueryString.StartDateDay);
				}
				catch(e) { return false; }
			}();
			this.EndDateIsValid = function() {
				try {
					var chkDate = new Date(sbSearch.QueryString.EndDateYear, (sbSearch.QueryString.EndDateMonth - 1), sbSearch.QueryString.EndDateDay);
					return (chkDate.getFullYear() == sbSearch.QueryString.EndDateYear) && ((chkDate.getMonth() + 1) == sbSearch.QueryString.EndDateMonth) && (chkDate.getDate() == sbSearch.QueryString.EndDateDay);
				}
				catch(e) { return false; }
			}();
			this.NumRooms = sbSearch.ParseInt(sbSearch.GetQS('ddlCamere'));
			this.NumPersons = sbSearch.ParseInt(sbSearch.GetQS('ddlPersone'));
			this.NumKids = sbSearch.ParseInt(sbSearch.GetQS('NB'));
			this.NumNights = sbSearch.ParseInt(sbSearch.GetQS('ddlNotti'));
			this.MealPlans = sbSearch.ParseInt(sbSearch.GetQS('IDT'));
			this.PromoCode = decodeURIComponent(sbSearch.GetQS('code'));
		}
	},
	Localize : {
		SundayFirst : false,
		FullMonth : [],
		SmallMonth : [],
		FullDay : [],
		SmallDay : [],
		MealPlan : [],
		MonthDescr : function(type) { return (type == 1) ? this.FullMonth : this.SmallMonth; },
		DayDescr : function(type) { return (type == 1) ? this.FullDay : this.SmallDay; },
		Initialize : function(codLingua) {
			if(codLingua != '') {
				try {
					this.SundayFirst = Localizations.SundayFirst[codLingua];
					this.FullMonth = Localizations.FullMonth[codLingua];
					this.SmallMonth = Localizations.SmallMonth[codLingua];
					this.FullDay = Localizations.FullDay[codLingua];
					this.SmallDay = Localizations.SmallDay[codLingua];
					this.MealPlan = Localizations.MealPlan[codLingua];
				}
				catch(e) {
					this.SundayFirst = Localizations.SundayFirst['EN'];
					this.FullMonth = Localizations.FullMonth['EN'],
					this.SmallMonth = Localizations.SmallMonth['EN'],
					this.FullDay = Localizations.FullDay['EN'],
					this.SmallDay = Localizations.SmallDay['EN'],
					this.MealPlan = Localizations.MealPlan['EN']
				}
			}
			if(!(this.FullMonth) || !(this.SmallMonth) || !(this.FullDay) || !(this.SmallDay) || !(this.MealPlan)) {
				this.SundayFirst = Localizations.SundayFirst['EN'];
				this.FullMonth = Localizations.FullMonth['EN'],
				this.SmallMonth = Localizations.SmallMonth['EN'],
				this.FullDay = Localizations.FullDay['EN'],
				this.SmallDay = Localizations.SmallDay['EN'],
				this.MealPlan = Localizations.MealPlan['EN']
			}
		}
	},
	FormEntities : {
		SearchForm : null,
		Guid : null,
		SearchButton : null,
		StartDay : null,
		StartMonth : null,
		StartYear : null,
		NumNights : null,
		EndDay : null,
		EndMonth : null,
		EndYear : null,

		StartFullDate : null,
		EndFullDate: null,
		HiddenStartDate: null,
		HiddenEndDate: null,

		NumPersons : null,
		NumKids : null,
		NumRooms : null,
		MealPlans : null,
		StartDayLabel : null,
		EndDayLabel : null,
		PromoCode : null,
		KidsAge : null,
		KidsAgeValues : null,
		KidsAgeLabels : null,

		CheckinLabel : null,
		CheckoutLabel : null,
		NumNightsLabel : null,
		NumRoomsLabel : null,
		NumPersonsLabel : null,
		MealPlanLabel : null,
		PromoCodeLabel : null,
		ModCancReservationLabel : null,
		OpenSbPromoCodeLabel : null,
		InfoSslLabel : null,
		TravelWithKidsLabel: null,
		SelectPropertyLabel: null,

		GetFromType : function(type) {
			return {
				Day : ((type == "1") ? this.EndDay: this.StartDay),
				Month : ((type == "1") ? this.EndMonth : this.StartMonth),
				Year : ((type == "1") ? this.EndYear : this.StartYear),
				FullDate : ((type == "1") ? this.EndFullDate : this.StartFullDate),
				HiddenField : ((type == "1") ? this.HiddenEndDate : this.HiddenStartDate)
			};
		},
		Initialize : function() {
			this.SearchForm = sbSearch.GetObj(sbSearch.Parameters.SearchFormId);
			this.Guid = sbSearch.GetObj(sbSearch.Parameters.GuidId);
			this.SearchButton = sbSearch.GetObj(sbSearch.Parameters.SearchButtonId);
			this.StartDay = sbSearch.GetObj(sbSearch.Parameters.StartDayId);
			this.StartMonth = sbSearch.GetObj(sbSearch.Parameters.StartMonthId);
			this.StartYear = sbSearch.GetObj(sbSearch.Parameters.StartYearId);
			this.EndDay = sbSearch.GetObj(sbSearch.Parameters.EndDayId);
			this.EndMonth = sbSearch.GetObj(sbSearch.Parameters.EndMonthId);
			this.EndYear = sbSearch.GetObj(sbSearch.Parameters.EndYearId);
			this.NumNights = sbSearch.GetObj(sbSearch.Parameters.NumNightsId);
			this.NumPersons = sbSearch.GetObj(sbSearch.Parameters.NumPersonsId);
			this.NumKids = sbSearch.GetObj(sbSearch.Parameters.NumKidsId);
			this.NumRooms = sbSearch.GetObj(sbSearch.Parameters.NumRoomsId);
			this.MealPlans = sbSearch.GetObj(sbSearch.Parameters.MealPlansId);
			this.StartDayLabel = sbSearch.GetObj(sbSearch.Parameters.StartDayLabelId);
			this.EndDayLabel = sbSearch.GetObj(sbSearch.Parameters.EndDayLabelId);
			this.PromoCode = sbSearch.GetObj(sbSearch.Parameters.PromoCodeId);

			this.StartFullDate = sbSearch.GetObj(sbSearch.Parameters.StartFullDateId);
			this.EndFullDate = sbSearch.GetObj(sbSearch.Parameters.EndFullDateId);
			this.HiddenStartDate = sbSearch.GetObj(sbSearch.Parameters.HiddenStartDateId);
			this.HiddenEndDate = sbSearch.GetObj(sbSearch.Parameters.HiddenEndDateId);

			this.CheckinLabel = sbSearch.GetObj(sbSearch.Parameters.CheckinLabelId);
			this.CheckoutLabel = sbSearch.GetObj(sbSearch.Parameters.CheckoutLabelId);
			this.NumNightsLabel = sbSearch.GetObj(sbSearch.Parameters.NumNightsLabelId);
			this.NumRoomsLabel = sbSearch.GetObj(sbSearch.Parameters.NumRoomsLabelId);
			this.NumPersonsLabel = sbSearch.GetObj(sbSearch.Parameters.NumPersonsLabelId);
			this.MealPlanLabel = sbSearch.GetObj(sbSearch.Parameters.MealPlanLabelId);
			this.PromoCodeLabel = sbSearch.GetObj(sbSearch.Parameters.PromoCodeLabelId);
			this.ModCancReservationLabel = sbSearch.GetObj(sbSearch.Parameters.ModCancReservationLabelId);
			this.OpenSbPromoCodeLabel = sbSearch.GetObj(sbSearch.Parameters.OpenSbPromoCodeLabelId);
			this.InfoSslLabel = sbSearch.GetObj(sbSearch.Parameters.InfoSslLabelId);
			this.TravelWithKidsLabel = sbSearch.GetObj(sbSearch.Parameters.TravelWithKidsLabelId);
			this.SelectPropertyLabel = sbSearch.GetObj(sbSearch.Parameters.SelectPropertyLabelId);
			
			this.KidsAge = new Array();
			this.KidsAgeValues = new Array();
			this.KidsAgeLabels = new Array();

			for(var i = 1; i <= sbSearch.Parameters.MaxRooms; i++) {

				this.KidsAgeLabels.push({
					NumAdultsLabel : 
						sbSearch.GetObj(sbSearch.Parameters.NumAdultsLabelId.replace('{{ROOM_INDEX}}', i)) ? 
							sbSearch.GetObj(sbSearch.Parameters.NumAdultsLabelId.replace('{{ROOM_INDEX}}', i)) : 
							sbSearch.GetObj(sbSearch.Parameters.NumPersonsRoomIndexLabelId.replace('{{ROOM_INDEX}}', i)),
					NumKidsLabel : sbSearch.GetObj(sbSearch.Parameters.NumKidsLabelId.replace('{{ROOM_INDEX}}', i)),
					KidAgeLabel : sbSearch.GetObj(sbSearch.Parameters.KidAgeLabelId.replace('{{ROOM_INDEX}}', i)),
					RoomAllocationLabel : sbSearch.GetObj(sbSearch.Parameters.RoomAllocationLabelId.replace('{{ROOM_INDEX}}', i))
				});

				var roomKidAgeArray = new Array();
				for(var k = 1; k <= sbSearch.Parameters.MaxKids; k++) {
					roomKidAgeArray.push({
						RoomKidAgeBlock : sbSearch.GetObj(sbSearch.Parameters.KidsAgeIds.RoomKidAgeBlockId.replace('{{ROOM_INDEX}}', i).replace('{{KID_INDEX}}', k)),
						RoomKidAgeField : sbSearch.GetObj(sbSearch.Parameters.KidsAgeIds.RoomKidAgeFieldId.replace('{{ROOM_INDEX}}', i).replace('{{KID_INDEX}}', k))
					});
					if (roomKidAgeArray[(k-1)].RoomKidAgeField)
						sbSearch.EmptyDropDownList(roomKidAgeArray[(k-1)].RoomKidAgeField);
				}
				this.KidsAge.push({
					RoomAdultsKidsBlock : sbSearch.GetObj(sbSearch.Parameters.KidsAgeIds.RoomAdultsKidsBlockId.replace('{{ROOM_INDEX}}', i)),
					RoomAdultField : sbSearch.GetObj(sbSearch.Parameters.KidsAgeIds.RoomAdultFieldId.replace('{{ROOM_INDEX}}', i)),
					RoomKidField : sbSearch.GetObj(sbSearch.Parameters.KidsAgeIds.RoomKidFieldId.replace('{{ROOM_INDEX}}', i)),
					RoomKidAgeArray : roomKidAgeArray
				});
				if (this.KidsAge[(i-1)].RoomAdultField)
					sbSearch.EmptyDropDownList(this.KidsAge[(i-1)].RoomAdultField);
				if (this.KidsAge[(i-1)].RoomKidField)
					sbSearch.EmptyDropDownList(this.KidsAge[(i-1)].RoomKidField);
			}
			sbSearch.UseKidsAge = (this.KidsAge.length > 0);
			
			sbSearch.UseSingleDateField = (this.StartFullDate != null);
			sbSearch.CalculateNights = (this.NumNights != null);

			return (this.SearchForm != null);
		}
	},
	CheckForm : function() {
		if (this.FormEntities.StartFullDate == null && (this.FormEntities.StartDay == null || this.FormEntities.StartMonth == null || this.FormEntities.StartYear == null)){ 
			sbSearch.ConfigErrors.push('Arrival date fields missing or misconfigured');
			this.FormChecked = false; 
			return; 
		}
		if (this.FormEntities.EndFullDate == null && this.FormEntities.NumNights == null && (this.FormEntities.EndDay == null || this.FormEntities.EndMonth == null || this.FormEntities.EndYear == null)) { 
			sbSearch.ConfigErrors.push('Departure date fields missing or misconfigured');
			this.FormChecked = false; 
			return; 
		}
		if (this.FormEntities.NumRooms == null) { 
			sbSearch.ConfigErrors.push('Number of rooms field missing or misconfigured');
			this.FormChecked = false; 
			return; 
		}
		if (this.FormEntities.NumPersons == null && this.FormEntities.KidsAge.length == 0) { 
			sbSearch.ConfigErrors.push('Number of persons / kids fields missing or misconfigured');
			this.FormChecked = false; 
			return; 
		}

		this.FormChecked = true;
	},
	Today : new function() {
	    this.Date = new Date();
	    this.Day = this.Date.getDate();
	    this.Month = this.Date.getMonth();
	    this.Year = this.Date.getFullYear();
	    this.Date = new Date(parseInt(this.Year, 10), parseInt(this.Month, 10), parseInt(this.Day, 10));
	},
	FirstDate : new function() {
		this.Date = new Date();
		this.Day = this.Date.getDate();
		this.Month = this.Date.getMonth();
		this.Year = this.Date.getFullYear();
		this.CalculateFirstDate = function (releaseDays, checkInDays) {
		    this.Date = new Date(parseInt(sbSearch.Today.Year, 10), parseInt(sbSearch.Today.Month, 10), parseInt(sbSearch.Today.Day, 10) + releaseDays - 1);
			this.Day = this.Date.getDate();
			this.Month = this.Date.getMonth();
			this.Year = this.Date.getFullYear();
			var loop = true;
			while(loop) {
				this.Date = new Date(parseInt(this.Year, 10), parseInt(this.Month, 10), parseInt(this.Day, 10) + 1);
				this.Day = this.Date.getDate();
				this.Month = this.Date.getMonth();
				this.Year = this.Date.getFullYear();
				for(var i = 0, l = checkInDays.length; i < l; i++) {
					if(this.Date.getDay() == parseInt(checkInDays[i], 10)) {
						loop = false;
						break;
					}
				}
			}
		};
	},
	LocalizeLabelObjects : function() {
		this.ReplaceText(this.FormEntities.CheckinLabel, Localizations.Labels.CheckinDate[this.Parameters.CodLang]);
		this.ReplaceText(this.FormEntities.CheckoutLabel, Localizations.Labels.CheckoutDate[this.Parameters.CodLang]);
		this.ReplaceText(this.FormEntities.NumNightsLabel, Localizations.Labels.NumNights[this.Parameters.CodLang]);
		this.ReplaceText(this.FormEntities.NumRoomsLabel, Localizations.Labels.NumRooms[this.Parameters.CodLang]);
		this.ReplaceText(this.FormEntities.NumPersonsLabel, Localizations.Labels.NumPersons[this.Parameters.CodLang]);
		this.ReplaceText(this.FormEntities.MealPlanLabel, Localizations.Labels.MealPlan[this.Parameters.CodLang]);
		this.ReplaceText(this.FormEntities.PromoCodeLabel, Localizations.Labels.PromoCode[this.Parameters.CodLang]);
		this.ReplaceText(this.FormEntities.SearchButton, Localizations.Labels.CheckAvailability[this.Parameters.CodLang]);
		this.ReplaceText(this.FormEntities.ModCancReservationLabel, Localizations.Labels.ModCancReservation[this.Parameters.CodLang]);
		this.ReplaceText(this.FormEntities.OpenSbPromoCodeLabel, Localizations.Labels.OpenSbPromoCode[this.Parameters.CodLang]);
		this.ReplaceText(this.FormEntities.InfoSslLabel, Localizations.Labels.InfoSSL[this.Parameters.CodLang]);
		this.ReplaceText(this.FormEntities.TravelWithKidsLabel, Localizations.Labels.TravelWithKids[this.Parameters.CodLang]);
		this.ReplaceText(this.FormEntities.SelectPropertyLabel, Localizations.Labels.SelectProperty[this.Parameters.CodLang]);

		for(var i = 0, len = this.FormEntities.KidsAgeLabels.length; i < len; i++) {
			this.ReplaceText(this.FormEntities.KidsAgeLabels[i].NumAdultsLabel, 
				(this.FormEntities.KidsAgeLabels[i].NumAdultsLabel && this.FormEntities.KidsAgeLabels[i].NumAdultsLabel.id.indexOf('numadults') != -1) ? 
					Localizations.Labels.NumAdults[this.Parameters.CodLang] : 
					Localizations.Labels.NumPersons[this.Parameters.CodLang]);
			this.ReplaceText(this.FormEntities.KidsAgeLabels[i].NumKidsLabel, Localizations.Labels.NumKids[this.Parameters.CodLang]);
			this.ReplaceText(this.FormEntities.KidsAgeLabels[i].KidAgeLabel, Localizations.Labels.KidAge[this.Parameters.CodLang]);
			this.ReplaceText(this.FormEntities.KidsAgeLabels[i].RoomAllocationLabel, Localizations.Labels.RoomAllocation[this.Parameters.CodLang]+(i+1));
		}

	},
	ReplaceText : function (labelObj, text) {
		if(labelObj) {
			if(labelObj.nodeName == "INPUT") {
				labelObj.value = text;
			} else {
				labelObj.innerHTML = text;
			}
		}
	},
	PrepareFormFirstRun : function() {
		this.FirstDate.CalculateFirstDate(this.Parameters.ReleaseDays, this.Parameters.CheckInDays);

		if (this.FormEntities.StartDay) {
			this.FormEntities.StartDay.onchange = function() { sbSearch.CheckSelectedDates(); }
			this.DropDownListGenericPopulate(this.FormEntities.StartDay, 1, 31);
		}
		if (this.FormEntities.StartMonth) {
			this.FormEntities.StartMonth.onchange = function() { sbSearch.SetDaysValues('0'); sbSearch.CheckSelectedDates(); }
			this.DropDownListMonthsPopulate(this.FormEntities.StartMonth);
		}
		if (this.FormEntities.StartYear) {
			this.FormEntities.StartYear.onchange = function() { sbSearch.SetDaysValues('0'); sbSearch.CheckSelectedDates(); }
			this.DropDownListYearsPopulate(this.FormEntities.StartYear);
		}

		if (!this.CalculateNights) {
			if (this.FormEntities.EndDay) {
				this.FormEntities.EndDay.onchange = function() { sbSearch.CheckSelectedDates(); }
				this.DropDownListGenericPopulate(this.FormEntities.EndDay, 1, 31);
			}
			if (this.FormEntities.EndMonth) {
				this.FormEntities.EndMonth.onchange = function() { sbSearch.SetDaysValues('1'); sbSearch.CheckSelectedDates(); }
				this.DropDownListMonthsPopulate(this.FormEntities.EndMonth);
			}
			if (this.FormEntities.EndYear) {
				this.FormEntities.EndYear.onchange = function() { sbSearch.SetDaysValues('1'); sbSearch.CheckSelectedDates(); }
				this.DropDownListYearsPopulate(this.FormEntities.EndYear);
			}
		} else {
			this.DropDownListGenericPopulate(this.FormEntities.NumNights, this.Parameters.MinStay, 31, false, (!this.Parameters.OnlyMultiplies ? 1 : this.Parameters.MinStay));
		}

		if(this.UseKidsAge && !this.FormEntities.NumPersons) {
			if (this.FormEntities.NumRooms) {
				this.DropDownListGenericPopulate(this.FormEntities.NumRooms, 1, this.Parameters.MaxRooms, false);
				if(this.QueryString.NumRooms <= this.FormEntities.NumRooms.options.length) {
					this.FormEntities.NumRooms.options[(this.QueryString.NumRooms - 1)].selected = true;
				}
				this.PrepareRoomFields();
				this.FormEntities.NumRooms.onchange = function() { sbSearch.PrepareRoomFields(); };
			}
		} else {
			if (this.FormEntities.NumPersons) {
				this.FormEntities.NumPersons.onchange = function() { sbSearch.CheckRoomNumber(); }
				var limit = (this.Parameters.MaxAdults == 6) ? 8 : this.Parameters.MaxAdults;
				this.DropDownListGenericPopulate(this.FormEntities.NumPersons, 1, (this.Parameters.Use12PersonLimit ? 12 : limit), false);
				if(isNaN(this.QueryString.NumPersons)) {
					this.FormEntities.NumPersons.options[(this.Parameters.DefaultPersons - 1)].selected = true;
				} else if(this.QueryString.NumPersons <= this.FormEntities.NumPersons.options.length) {
					this.FormEntities.NumPersons.options[(this.QueryString.NumPersons - 1)].selected = true;
				}
			}

			if (this.FormEntities.NumRooms) {
				if(isNaN(this.QueryString.NumPersons)) {
					this.DropDownListGenericPopulate(this.FormEntities.NumRooms, 1, 2, false);
				} else if(this.QueryString.NumPersons <= this.FormEntities.NumPersons.options.length) {
					this.DropDownListGenericPopulate(this.FormEntities.NumRooms, 1, this.QueryString.NumPersons, false);
				}
				if(isNaN(this.QueryString.NumRooms)) {
					this.FormEntities.NumRooms.options[0].selected = true;
				} else if(this.QueryString.NumRooms <= this.FormEntities.NumRooms.options.length) {
					this.FormEntities.NumRooms.options[(this.QueryString.NumRooms - 1)].selected = true;
				}
			}

			if (this.FormEntities.NumKids) {
				this.DropDownListGenericPopulate(this.FormEntities.NumKids, 0, 4, false);
			}
		}
				
		if (this.QueryString.StartDateIsValid) {
			this.SetDaysValues('0', this.QueryString.StartDateDay, this.QueryString.StartDateMonth, this.QueryString.StartDateYear);
		} else if (this.Parameters.Checkin != null) {
			var aryDate = this.Parameters.Checkin.split('-');
			this.SetDaysValues('0', parseInt(aryDate[2], 10), parseInt(aryDate[1], 10), parseInt(aryDate[0], 10));
		} else {
			this.SetDaysValues('0', this.FirstDate.Day, (this.FirstDate.Month + 1), this.FirstDate.Year);
		}
		if (this.CalculateNights) {
			if(!isNaN(this.QueryString.NumNights)) {
				this.DropDownListFindByValue(this.FormEntities.NumNights, this.QueryString.NumNights);
			} else {
				var startDate = this.GetStartDate();
				var endDate = null;
				if(this.QueryString.EndDateIsValid) {
					endDate = new Date(this.QueryString.EndDateYear, (this.QueryString.EndDateMonth - 1), this.QueryString.EndDateDay);
				} else if (this.Parameters.Checkout != null) {
					var aryDate = this.Parameters.Checkout.split('-');
					endDate = new Date(parseInt(aryDate[0], 10), parseInt(aryDate[1], 10) - 1, parseInt(aryDate[2], 10));
				}
				if(endDate != null) {
					var nDays = this.DateDiffNumDays(endDate, startDate);
					if(nDays > 1) {
						this.DropDownListFindByValue(this.FormEntities.NumNights, nDays);
					}
				}
			}
		} else if(this.UseSingleDateField) {
			this.SetDaysValues('1', this.FirstDate.Day, (this.FirstDate.Month + 1), this.FirstDate.Year);
		} else if(this.QueryString.EndDateIsValid) {
			this.SetDaysValues('1', this.QueryString.EndDateDay, this.QueryString.EndDateMonth, this.QueryString.EndDateYear);
		} else if (this.Parameters.Checkout != null) {
			var aryDate = this.Parameters.Checkout.split('-');
			this.SetDaysValues('1', parseInt(aryDate[2], 10), parseInt(aryDate[1], 10), parseInt(aryDate[0], 10));
		}

		if(this.FormEntities.MealPlans) {
			this.DropDownListMealPlansPopulate(this.FormEntities.MealPlans);
			if(!isNaN(this.QueryString.MealPlans)) {
				this.DropDownListFindByValue(this.FormEntities.MealPlans, this.QueryString.MealPlans);
			}
			if(this.FormEntities.MealPlans.options.length == 2) {
				this.FormEntities.MealPlans.remove(0);
			}
		}
		if(this.FormEntities.PromoCode && this.QueryString.PromoCode) {
			this.FormEntities.PromoCode.value = this.QueryString.PromoCode;
		}

		if(this.FormEntities.SearchButton) {
			this.FormEntities.SearchButton.onclick = function() { sbSearch.Search(); };
			if(this.FormEntities.SearchForm) {
				this.FormEntities.SearchForm.onsubmit = function() { return false; };
			}
		}
	},
	GetSelectedGuid : function() {
		if(this.FormEntities.Guid) {
			if(this.FormEntities.Guid.selectedIndex) {
				return this.FormEntities.Guid[this.FormEntities.Guid.selectedIndex].value;
			} else {
				return this.FormEntities.Guid.value;
			}
		} else {
			return this.Parameters.GuidProperty;
		}
	},
	GetSelectedId : function() {
		if(this.FormEntities.Guid) {
			if(this.FormEntities.Guid.selectedIndex != undefined && this.FormEntities.Guid.selectedIndex != -1) {
				return this.FormEntities.Guid[this.FormEntities.Guid.selectedIndex].value;
			} else {
				return this.Parameters.HotelId;
			}
		} else {
			return this.Parameters.HotelId;
		}
	},
	AddOnChangeEvent : function(object, func) {
		if ( object.addEventListener ) {
			object.addEventListener( "change", func, false );
		} else if ( object.attachEvent ) {
			object.attachEvent("onchange", func);
		} else if ( object.onchange ) {
			object.onchange = func;
		}
	},
	EmptyDropDownList : function(ddl) {
		var i = ddl.options.length;
		while(i--) { ddl.remove(i); }	
	},
	DropDownListFindByValue : function(ddl, value) {
		for(var i = 0; i < ddl.options.length; i++) {
			if(ddl.options[i].value == value) {
				ddl.options[i].selected = true;
				break;
			}
		}
	},
	DropDownListGenericPopulate : function(ddl, start, end, addZero, multiplier) {
		if(ddl != null) {
			multiplier = (!multiplier) ? 1 : multiplier;
			this.EmptyDropDownList(ddl);
			addZero = (addZero == null) ? true : addZero;
			for(var i = start; i <= end; i++) {
				if(i % multiplier == 0) {
					var str = new String(i);
					if (addZero && str.length < 2) str = '0' + str;
					ddl.options.add(new Option(str, i));
				}
			}
		}
	},
	DropDownListMonthsPopulate : function(ddl) {
		if(ddl != null) {
			this.EmptyDropDownList(ddl);
			for(var i = 0; i < 12; i++) {
				ddl.options.add(new Option(
					unescape(this.Localize.MonthDescr(this.Parameters.MonthLengthType)[i]),
					(i+1)
				));
			}
		}
	},
	DropDownListYearsPopulate : function(ddl) {
		if(ddl != null) {
			this.EmptyDropDownList(ddl);
			for(var i = 0; i < 3; i++) {
				var val = this.FirstDate.Year + i;
				var txt = (this.Parameters.YearLengthType == 1) ? val : new String(val).substring(2,4);
				ddl.options.add(new Option(txt, val));
			}
		}
	},
	DropDownListMealPlansPopulate : function(ddl) {
		this.EmptyDropDownList(ddl);
		ddl.options.add(new Option(this.Localize.MealPlan[0], 0));
		for(var i = 0; i < this.Parameters.AvailableMealPlans.length; i++) {
			var val = this.Parameters.AvailableMealPlans[i];
			ddl.options.add(new Option(unescape(this.Localize.MealPlan[val], val)));
		}
	},
	CheckDayForCheckIn : function(day) {
		if(day == null) return false;
		for(var i = 0; i < this.Parameters.CheckInDays.length; i++) {
			if(day.getDay() == parseInt(this.Parameters.CheckInDays[i], 10))
				return true;
		}
		return false;
	},
	DateDiffNumDays : function(dateA, dateB) {
		var milSec = dateA.valueOf() - dateB.valueOf();
		return Math.round(milSec/1000/60/60/24);
	},
	GetStartDate : function() {
		if(!this.UseSingleDateField) {
			var startYear, startMonth, startDay;
			if (this.FormEntities.StartYear)
				startYear = parseInt(this.FormEntities.StartYear[this.FormEntities.StartYear.selectedIndex].value, 10);
			if (this.FormEntities.StartMonth)
				startMonth = parseInt(this.FormEntities.StartMonth[this.FormEntities.StartMonth.selectedIndex].value, 10);
			if (this.FormEntities.StartDay)
				startDay = parseInt(this.FormEntities.StartDay[this.FormEntities.StartDay.selectedIndex].value, 10);
			return new Date(startYear, (startMonth - 1), startDay);
		} else {
			var aryDate = this.FormEntities.HiddenStartDate.value.split('-');
			var date = new Date(parseInt(aryDate[0], 10), (parseInt(aryDate[1], 10) - 1), parseInt(aryDate[2], 10));
			return (isNaN(date.getTime())) ? new Date(1,1,1) : date;
		}
	},
	GetEndDate : function() {
		var endYear, endMonth, endDay, numNights;
		if(!this.CalculateNights) {
			if(this.UseSingleDateField) {
				var aryDate = this.FormEntities.HiddenEndDate.value.split('-');
				var date = new Date(parseInt(aryDate[0], 10), (parseInt(aryDate[1], 10) - 1), parseInt(aryDate[2], 10));
				return (isNaN(date.getTime())) ? new Date(1,1,1) : date;
			} else {
				if (this.FormEntities.EndYear)
					endYear = parseInt(this.FormEntities.EndYear[this.FormEntities.EndYear.selectedIndex].value, 10);
				if (this.FormEntities.EndMonth)
					endMonth = parseInt(this.FormEntities.EndMonth[this.FormEntities.EndMonth.selectedIndex].value, 10);
				if (this.FormEntities.EndDay)
					endDay = parseInt(this.FormEntities.EndDay[this.FormEntities.EndDay.selectedIndex].value, 10);
				return new Date(endYear, (endMonth - 1), endDay);
			}
		} else {
			numNights = parseInt(this.FormEntities.NumNights[this.FormEntities.NumNights.selectedIndex].value, 10);
			return new Date(this.GetStartDate().getFullYear(), this.GetStartDate().getMonth(), parseInt(this.GetStartDate().getDate()) + parseInt(numNights));
		}
	},
	PrepareRoomFields : function(ddlCam) {
		var numRooms = sbSearch.FormEntities.NumRooms;
		var rooms = parseInt(numRooms[numRooms.selectedIndex].value, 10);
		for(var i = 0; i < sbSearch.Parameters.MaxRooms; i++) {
			var roomAdultsKidsBlock = sbSearch.FormEntities.KidsAge[i].RoomAdultsKidsBlock;
			if(roomAdultsKidsBlock != null) {
				if(i < rooms) {
					sbSearch.PrepareRoom(i);
					roomAdultsKidsBlock.style.display = 'block';
				} else {
					sbSearch.RemoveRoom(i);
					roomAdultsKidsBlock.style.display = 'none';
				}
			}
			if(sbSearch.FormEntities.KidsAge[i].RoomKidField != null && sbSearch.FormEntities.KidsAge[i].RoomKidField.options.length > 0) {
				sbSearch.PrepareKidAgeFields(i);
				var callBack = (function(idx) { return function() { sbSearch.PrepareKidAgeFields(idx); } })(i);
				sbSearch.FormEntities.KidsAge[i].RoomKidField.onchange = callBack;
			}
		}
	},
	PrepareKidAgeFields : function(idxCam) {
		var kidField = sbSearch.FormEntities.KidsAge[idxCam].RoomKidField;
		var kids = parseInt(kidField[kidField.selectedIndex].value, 10);
		for(var i = 0; i < sbSearch.Parameters.MaxKids; i++) {
			var kidAgeBlock = sbSearch.FormEntities.KidsAge[idxCam].RoomKidAgeArray[i].RoomKidAgeBlock;
			if(kidAgeBlock != null) {
				if(i < kids)
					kidAgeBlock.style.display = 'block';
				else
					kidAgeBlock.style.display = 'none';
			}
		}
	},
	PrepareRoom : function(idxCam) {
		var adultField = sbSearch.FormEntities.KidsAge[idxCam].RoomAdultField;
		var kidField = sbSearch.FormEntities.KidsAge[idxCam].RoomKidField;
		if(adultField.options.length != sbSearch.Parameters.MaxAdults) {
			for(i = 1; i <= sbSearch.Parameters.MaxAdults; i++) {
				var idx = adultField.options.length;
				adultField.options[idx] = new Option(i);
				adultField.options[idx].value = i;
				if(sbSearch.FormEntities.KidsAgeValues.length >= (idxCam + 1)) {
					if(i == sbSearch.AdultCount(sbSearch.FormEntities.KidsAgeValues[idxCam])) {
						adultField.options[idx].selected = true;
					}
					else if(i == this.Parameters.DefaultPersons && ddlA.selectedIndex == -1) {
						adultField.options[idx].selected = true;
					}
				}
				else if(i == this.Parameters.DefaultPersons) {
					adultField.options[idx].selected = true;
				}
			}
		}
		if(kidField != null && (kidField.options.length-1) != sbSearch.Parameters.MaxKids) {
			for(i = 0; i <= sbSearch.Parameters.MaxKids; i++) {
				var idx = kidField.options.length;
				kidField.options[idx] = new Option(i);
				kidField.options[idx].value = i;
				if(sbSearch.FormEntities.KidsAgeValues.length >= (idxCam + 1)) {
					if(i == sbSearch.KidCount(sbSearch.FormEntities.KidsAgeValues[idxCam])) {
						kidField.options[idx].selected = true;
						sbSearch.PrepareKidAgeFields(idxCam);
					}
				}
			}
		}
		for(var i = 0; i < sbSearch.Parameters.MaxKids; i++) {
			var kidAgeField = sbSearch.FormEntities.KidsAge[idxCam].RoomKidAgeArray[i].RoomKidAgeField;
			if (kidAgeField != null && kidAgeField.options.length != ((sbSearch.Parameters.MaxKidsAge - sbSearch.Parameters.MinKidsAge) + 2)) {
				var ChkKid = 0;
				var idx = kidAgeField.options.length;
				kidAgeField.options[idx] = new Option('');
				kidAgeField.options[idx].value = '';
				for (var e = sbSearch.Parameters.MinKidsAge; e <= sbSearch.Parameters.MaxKidsAge; e++) {
					idx = kidAgeField.options.length;
					kidAgeField.options[idx] = new Option(e);
					kidAgeField.options[idx].value = e;
					if (sbSearch.FormEntities.KidsAgeValues.length >= (idxCam + 1)) {
						if (e == sbSearch.GetAge(sbSearch.FormEntities.KidsAgeValues[idxCam], i))
							kidAgeField.options[idx].selected = true;
					}
				}
			}
		}
	},
	RemoveRoom : function(idxCam) {
		var adultField = sbSearch.FormEntities.KidsAge[idxCam].RoomAdultField;
		var kidField = sbSearch.FormEntities.KidsAge[idxCam].RoomKidField;
		for(var a = adultField.options.length; a >= 0; a--) { adultField.options[a] = null; }
		if(kidField != null) {
			for(var b = kidField.options.length; b >= 0; b--) { kidField.options[b] = null; }
			for(var i = 0; i < sbSearch.Parameters.MaxKids; i++) {
				var kidAgeField = sbSearch.FormEntities.KidsAge[idxCam].RoomKidAgeArray[i].RoomKidAgeField;
				var kidAgeBlock = sbSearch.FormEntities.KidsAge[idxCam].RoomKidAgeArray[i].RoomKidAgeBlock;
				kidAgeBlock.style.display = 'none';
				for(var f = kidAgeField.options.length; f >= 0; f--) { kidAgeField.options[f] = null; }
			}
		}
	},
	PrepareKidsAgeValues : function()
	{
		sbSearch.FormEntities.KidsAgeValues = new Array();
		var roomField = sbSearch.FormEntities.NumRooms;
		var numRooms = parseInt(roomField[roomField.selectedIndex].value, 10);
		for(var i = 0; i < numRooms; i++)
		{
			var roomKidsAgeValue = '';
			if(i < sbSearch.FormEntities.KidsAge.length) 
			{
				var roomAdultsKidsBlock = sbSearch.FormEntities.KidsAge[i].RoomAdultsKidsBlock;
				if(roomAdultsKidsBlock != null && roomAdultsKidsBlock.style.display != 'none')
				{
					var roomAdultField = sbSearch.FormEntities.KidsAge[i].RoomAdultField;
					var roomKidField = sbSearch.FormEntities.KidsAge[i].RoomKidField;

					var numAdults = parseInt(roomAdultField[roomAdultField.selectedIndex].value, 10);
					for(var na = 1; na <= numAdults; na++)
						roomKidsAgeValue += ((roomKidsAgeValue.length > 0) ? ',' : '') + 'A';

					if(roomKidField != null)
					{
						var numKids = parseInt(roomKidField[roomKidField.selectedIndex].value, 10);
						for(var nb = 0; nb < numKids; nb++)
						{
							var roomKidAgeField = sbSearch.FormEntities.KidsAge[i].RoomKidAgeArray[nb].RoomKidAgeField;
							roomKidsAgeValue += ((roomKidsAgeValue.length > 0) ? ',' : '') + roomKidAgeField[roomKidAgeField.selectedIndex].value;
						}
					}
				}
			}
			if(roomKidsAgeValue.length > 0)
				sbSearch.FormEntities.KidsAgeValues.push(roomKidsAgeValue);
		}
	},
	AdultCount : function(str) {
		var ary = str.split(',');
		var ret = 0;
		for(var i = 0; i < ary.length; i++) {
			if(ary[i] == 'A') ret++;
		}
		return ret;
	},
	KidCount : function(str) {
		var ary = str.split(',');
		var ret = 0;
		for(var i = 0; i < ary.length; i++) {
			if(ary[i] != 'A') ret++;
		}
		return ret;
	},
	GetAge : function(str, idx) {
		var ary = str.split(',');
		var ret = 0;
		for(var i = 0; i < ary.length; i++) {
			if(ary[i] != 'A') { ret++; }
			if(idx == ret)
				return ary[i];
		}
		return 0;
	},

	_setHiddenDateFieldValue: function(type, selDay, selMonth, selYear) {
		var hiddenField = this.FormEntities.GetFromType(type).HiddenField;
		if(hiddenField == null) return;
		var selDate = selYear + '-' + selMonth + '-' + selDay;
		if(hiddenField.value == "" || hiddenField.value != selDate)
			hiddenField.value = selDate;
	},
	
	SetDaysValues : function(type, selDay, selMonth, selYear) {
		if(!this.FormChecked) { this.ShowErrConfig(); return; }
		type = (type == null) ? '0' : type;
		selDay = (selDay == null) ? -1 : selDay;
		selMonth = (selMonth == null) ? -1 : selMonth;
		selYear = (selYear == null) ? -1 : selYear;
		
		if(this.UseSingleDateField) { 
			this._setDaysSingleField(type, selDay, selMonth, selYear);
		} else {
			this._setDaysDropDownList(type, selDay, selMonth, selYear);
		}
	},
	_setDaysSingleField: function(type, selDay, selMonth, selYear) {
		var dateField = this.FormEntities.GetFromType(type).FullDate;
		
		this._setHiddenDateFieldValue(type, selDay, selMonth, selYear);
		
		var monthString = unescape(this.Localize.MonthDescr(this.Parameters.MonthLengthType)[(selMonth-1)]);
		
		dateField.value = selDay + ' ' + monthString + ' ' + selYear;
		
		this.CheckSelectedDates();
		this.PrintDayLabel();
	},
	_setDaysDropDownList: function (type, selDay, selMonth, selYear) {
		var dayObj = this.FormEntities.GetFromType(type).Day;
		var monthObj = this.FormEntities.GetFromType(type).Month;
		var yearObj = this.FormEntities.GetFromType(type).Year;

		var checkDate = new Date(parseInt(selYear, 10), parseInt(selMonth, 10)-1, parseInt(selDay, 10));
		
		var months = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12];
		var febDays = 28
		var checkYear = (selYear == -1) ? yearObj[yearObj.selectedIndex].value : selYear;
		febDays = ((checkYear % 400 == 0) || ((checkYear % 4 == 0) && (checkYear % 100 !=0))) ? 29 : 28;
		var aryTotDays = [31, febDays, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
		var oldSelDay = -1;
		if(dayObj.selectedIndex != -1) {oldSelDay = parseInt(dayObj[dayObj.selectedIndex].value, 10);}
		if(selDay != -1) { oldSelDay = selDay; }
		if(selYear != -1) { this.DropDownListFindByValue(yearObj, selYear); }
		else { selYear = parseInt(yearObj[yearObj.selectedIndex].value, 10); }
		this.EmptyDropDownList(dayObj);
		if(selMonth == -1) { selMonth = parseInt(monthObj[monthObj.selectedIndex].value, 10); }
		var idxMonth = (selMonth-1);
		for(var d = 1; d <= aryTotDays[idxMonth]; d++) {
			var checkDateForCheckIn = new Date(selYear, idxMonth, d);
			var checkinDay = true; //(checkDateForCheckIn >= this.FirstDate.Date);
			if(type == '0' || this.Parameters.OnlyMultiplies) {
				checkinDay = this.CheckDayForCheckIn(checkDateForCheckIn); // && (checkDateForCheckIn >= this.FirstDate.Date);
			}
			if(checkinDay) {
				var str = new String(d);
				var opt = new Option(((str.length < 2) ? '0' + str : str), d);
				opt.selected = (oldSelDay != -1 && oldSelDay == d);
				dayObj.options.add(opt);
			}
		}
		if(this.Parameters.OnlyMultiplies && (dayObj.selectedIndex == -1 || dayObj[dayObj.selectedIndex].value < selDay)) {
			this.SetDaysValues(type, 1, selMonth, selYear);
		}
		if(dayObj.selectedIndex == -1) {
			this.DropDownListFindByValue(dayObj, this.FirstDate.Day);
			if(dayObj.selectedIndex == -1 && dayObj.options.length > 0) {dayObj.options[0].selected = true;}
		} else {
			if(
				dayObj[dayObj.selectedIndex].value < this.FirstDate.Day && 
				this.FirstDate.Date > checkDate && 
				(
					type != '1' &&
					monthObj.selectedIndex == this.FirstDate.Month
				)
			) {
				dayObj.selectedIndex = -1;
				for(var i = 0; i < dayObj.options.length; i++) {
					if(parseInt(dayObj.options[i].value) >= this.FirstDate.Day) {
						dayObj.options[i].selected = true; 
						break; 
					}
				}				
			}
		}

		if(selMonth != -1) { this.DropDownListFindByValue(monthObj, selMonth); }

		this.CheckSelectedDates();
		this.PrintDayLabel();
	},
	CheckSelectedDates : function() {
		if(!this.FormChecked) { this.ShowErrConfig(); return; }
		var startDate = this.GetStartDate();
		if(startDate < this.FirstDate.Date) this.SetDaysValues('0', this.FirstDate.Day, this.FirstDate.Month + 1, this.FirstDate.Year);
		this._setHiddenDateFieldValue('0', startDate.getDate(), startDate.getMonth() + 1, startDate.getFullYear());
		var endDate = this.GetEndDate();
		if(!this.CalculateNights) {
			this._setHiddenDateFieldValue('1', endDate.getDate(), endDate.getMonth() + 1, endDate.getFullYear());
			var nDays = this.DateDiffNumDays(endDate, startDate);
			if(nDays < this.Parameters.MinStay) {
				var newData = startDate;
				newData.setDate(newData.getDate() + this.Parameters.MinStay);
				this.SetDaysValues("1", newData.getDate(), newData.getMonth() + 1, newData.getFullYear());
			}
		}
		this.PrintDayLabel();
	},
	PrintDayLabel : function() {
		if(!this.FormChecked) { this.ShowErrConfig(); return; }
		if(this.FormEntities.StartDayLabel != null) {
			var startDate = this.GetStartDate();
			this.FormEntities.StartDayLabel.innerHTML = this.Localize.DayDescr(this.Parameters.DaysLengthType)[startDate.getDay()];
		}
		if(!this.CalculateNights && this.FormEntities.EndDayLabel != null) {
			var endDate = this.GetEndDate();
			this.FormEntities.EndDayLabel.innerHTML = this.Localize.DayDescr(this.Parameters.DaysLengthType)[endDate.getDay()];
		}		
	},
	CheckRoomNumber : function() {
		if(!this.FormChecked) { this.ShowErrConfig(); return; }
		if(this.FormEntities.NumRooms != null) {
			var numPersons = parseInt(this.FormEntities.NumPersons[this.FormEntities.NumPersons.selectedIndex].value, 10);
			var maxRooms = (numPersons > this.Parameters.TotRoomsHotel) ? this.Parameters.TotRoomsHotel : numPersons;
			var oldNumRooms = parseInt(this.FormEntities.NumRooms[this.FormEntities.NumRooms.selectedIndex].value, 10);
			this.DropDownListGenericPopulate(this.FormEntities.NumRooms, 1, maxRooms, false);
			if(oldNumRooms <= numPersons) { this.FormEntities.NumRooms[(oldNumRooms - 1)].selected = true; }
		}
	},
	GetObj :function (id) {
		return (document.getElementById) ? document.getElementById(id) : eval('document.all.' + id);
	},
	GetQS : function (key, defValue) {
		if (defValue == null) { defValue = ''; }
		key = key.replace(/[\[]/,'\\\[').replace(/[\]]/,'\\\]');
		var regex = new RegExp("[\\?&]"+key+"=([^&#]*)");
		var qs = regex.exec(window.location.href);
		return (qs == null) ? defValue : qs[1];
	},
	ParseInt : function(object) {
		try { return parseInt(object, 10); }
		catch(e) { return null; }
	},
	Extend : function(options, defaults) {
		var result = options || {}, name;
		for(name in defaults) {
			if(options[name] !== undefined && options[name] !== defaults[name]) {
				result[name] = options[name];
			} else {
				result[name] = defaults[name];
			}
		}
		return result;
	},
	Init : function(forceLoad) {
		if (!forceLoad) forceLoad = false;
		if (this.ScriptLoaded) return;
		this.Parameters = this.Extend(window.SBParameters || {}, this.Parameters);
		if(window.SBParameters)
			Localizations.Labels = this.Extend(window.SBParameters.Labels || {}, Localizations.Labels);
		sbSearch.Localize.Initialize(this.Parameters.CodLang);
		if(this.Parameters.HomesiteUrl == '') {
			this.Parameters.HomesiteUrl = window.location;
		}
		if(this.Parameters.CustomCalendarCssUrl != '') {
		    loadResource(this.Parameters.CustomCalendarCssUrl, 'css');
		}
		var chkFrm = sbSearch.FormEntities.Initialize();
		if(!chkFrm) return;
		sbSearch.QueryString.Initialize();
		sbSearch.LocalizeLabelObjects();

		var scriptLoadError = '';
		if(scriptLoadError != '') {
			sbSearch.ConfigErrors.push(scriptLoadError);
		}
		if(!forceLoad && !this.Parameters.AutoLoad) { return; }
		sbSearch.CheckForm();
		if(!sbSearch.FormChecked) { sbSearch.ShowErrConfig(); return; }
		if(scriptLoadError != '') { sbSearch.ShowErrConfig(); }
		sbSearch.PrepareFormFirstRun();
		if(sbSearch.Parameters.PlaceHolderId != '' && sbSearch.Parameters.SBContainerId != '' && sbSearch.Parameters.AbsolutePositionOnInit) {
			var phOffset = sbSearch.GetElementPosition(sbSearch.Parameters.PlaceHolderId);
			var container = sbSearch.GetObj(sbSearch.Parameters.SBContainerId);
			var cntStyle = (container.style) ? container.style : container;
			cntStyle.top = phOffset.top + 'px';
			cntStyle.left = phOffset.left + 'px';
		}
		if(this.Parameters.AfterInitCallBack) {
			this.Parameters.AfterInitCallBack();
		}
		this.ScriptLoaded = true;
	},
	Ready : function() {
		// Copy from jQuery.bindReady() function and modified (revisioned with jQuery 1.6.2)
		if (this.ScriptBound) return;
		this.ScriptBound = true;
		if ( document.addEventListener ) {
			document.addEventListener( "DOMContentLoaded", function(){
				document.removeEventListener( "DOMContentLoaded", arguments.callee, false );
				if ( sbSearch.ScriptLoaded ) return;
				sbSearch.Init();
			}, false );
			window.addEventListener( "DOMContentLoaded", function(){
				window.removeEventListener( "DOMContentLoaded", arguments.callee, false );
				if ( sbSearch.ScriptLoaded ) return;
				sbSearch.Init();
			}, false );
		} else if ( document.attachEvent ) {
			document.attachEvent("onreadystatechange", function(){
				if ( document.readyState === "complete" ) {
					document.detachEvent( "onreadystatechange", arguments.callee );
					if ( sbSearch.ScriptLoaded ) return;
					sbSearch.Init();
				}
			});
			window.attachEvent('onload', function() {
				window.detachEvent( 'onload', arguments.callee );
				if ( sbSearch.ScriptLoaded ) return;
				sbSearch.Init();
			});
		}
	},
	ShowErrConfig : function() {
		var strErrorMessage = 'Some configuration errors has occurred:\n' + this.ConfigErrors.join('\n');
		alert(strErrorMessage);
	},
	Search: function() {
		if(!this.FormChecked) { this.ShowErrConfig(); return; }
		var chk = this.ValidateForm();
		if(chk) {
			if(this.Parameters.UseNewBooking || this.Parameters.UseBookingInPage) {
				this.SearchPageBooking();
			} else {
				this.SearchWindow();
			}
		}
	},
	ValidateForm : function() {
		if(this.UseKidsAge && !this.FormEntities.NumPersons) {
			var roomField = sbSearch.FormEntities.NumRooms;
			var numRooms = parseInt(roomField[roomField.selectedIndex].value, 10);
			for(var i = 0; i < numRooms; i++)
			{
				var roomAdultsKidsBlock = sbSearch.FormEntities.KidsAge[i].RoomAdultsKidsBlock;
				if(roomAdultsKidsBlock != null && roomAdultsKidsBlock.style.display != 'none')
				{
					var roomKidField = sbSearch.FormEntities.KidsAge[i].RoomKidField;
					if(roomKidField != null)
					{
						var numKids = parseInt(roomKidField[roomKidField.selectedIndex].value, 10);
						for(var nb = 0; nb < numKids; nb++)
						{
							var roomKidAgeField = sbSearch.FormEntities.KidsAge[i].RoomKidAgeArray[nb].RoomKidAgeField;
							var roomKidsAgeValue = roomKidAgeField[roomKidAgeField.selectedIndex].value;
							if(!roomKidsAgeValue) {
								alert(unescape(Localizations.Errors.KidAgeRequired[this.Parameters.CodLang]));
								return false;
							}
						}
					}
				}
			}
		};
		return true;
	},
	GenerateBookingUrl : function(url) {
		if(this.FormEntities.KidsAge.length > 0)
			this.PrepareKidsAgeValues();

		var curPar = this.Parameters.Currency.length > 0 ? '&CUR=' + this.Parameters.Currency : '';
		var retVal = url + '?GUID=' + this.GetSelectedGuid();
		retVal += '&LANG=' + this.Parameters.CodLang;
		retVal += curPar;

		var startDate = this.GetStartDate();
		retVal += '&ddlArrivoAnno=' + startDate.getFullYear();
		retVal += '&ddlArrivoMese=' + (startDate.getMonth() + 1);
		retVal += '&ddlArrivoGiorno=' + startDate.getDate();

		var endDate = this.GetEndDate();
		retVal += '&ddlPartenzaAnno=' + endDate.getFullYear();
		retVal += '&ddlPartenzaMese=' + (endDate.getMonth() + 1);
		retVal += '&ddlPartenzaGiorno=' + endDate.getDate();

		if(this.FormEntities.NumPersons != null) {
			retVal += '&ddlPersone=' + this.FormEntities.NumPersons.value;
		} else {
			if(this.FormEntities.KidsAgeValues.length > 0) {
				retVal += '&ddlPersone=' + this.AdultCount(this.FormEntities.KidsAgeValues.join(','));
			}
		}
		if(this.FormEntities.KidsAgeValues.length > 0) {
			retVal += "&CAP=" + this.FormEntities.KidsAgeValues.join('|');
		}
		if(this.FormEntities.NumKids != null) {
			retVal += "&NB=" + this.FormEntities.NumKids.value;
		} else {
			if(this.FormEntities.KidsAgeValues.length > 0) {
				retVal += '&NB=' + this.KidCount(this.FormEntities.KidsAgeValues.join(','));
			} else {
				retVal += "&NB=0";
			}
		}
		if(this.FormEntities.MealPlans != null) {
			retVal += '&IDT=' + this.FormEntities.MealPlans.value;	
		}
		if(this.FormEntities.NumRooms != null) {
			retVal += '&ddlCamere=' + this.FormEntities.NumRooms.value;
		}
		if(this.FormEntities.PromoCode != null) {
		    retVal += '&code=' + encodeURIComponent(this.FormEntities.PromoCode.value);
		}
		retVal += '&CTRL=RIDI&STEP=2';
		if(this.Parameters.UseMobile()) {
			retVal += "&REFCODE=MOBILESITE&MOBILEURL=" + this.Parameters.HomesiteUrl;
		}
		return retVal;
	},
	GenerateNewBookingUrl : function(url) {
		if(this.FormEntities.KidsAge.length > 0)
			this.PrepareKidsAgeValues();

		//var retVal = url + '?hid=' +  this.Parameters.HotelId + '&lang=' + this.Parameters.CodLang + '#/q';
		var curPar = this.Parameters.Currency.length > 0 ? '&cur=' + this.Parameters.Currency : '';
		var retVal = url + '?hid=' +  this.GetSelectedId() + '&lang=' + this.Parameters.CodLang + curPar; 
		if(this.Parameters.UseMobile()) {
		    retVal += "&REFCODE=MOBILESITE&MOBILEURL=" + this.Parameters.HomesiteUrl;
		}
		retVal += '#/q';
		var startDate = this.GetStartDate();
		var endDate = this.GetEndDate();
		retVal += '&guests=';
		if(this.FormEntities.KidsAgeValues.length > 0) { retVal += this.FormEntities.KidsAgeValues.join('|'); }
		else if (this.FormEntities.NumPersons && this.FormEntities.NumPersons.selectedIndex != -1) {
			var numPersons = parseInt(this.FormEntities.NumPersons[this.FormEntities.NumPersons.selectedIndex].value, 10);
			var numRooms = parseInt(this.FormEntities.NumRooms[this.FormEntities.NumRooms.selectedIndex].value, 10);
			var distributedGuest = this.RoundNumber( numPersons / numRooms, 0);
			var guestCounted = 0;
			for ( var i = 1; i <= numRooms; i++ ) {
				if(i > 1) retVal += '|';
				if(i < numRooms) {
					guestCounted += distributedGuest;
					for (var a = 0; a < distributedGuest; a++) { retVal += ((a > 0) ? ',' : '') + 'A'; }
				} else {
					var differ = numPersons - guestCounted;
					for (var a = 0; a < differ; a++) { retVal += ((a > 0) ? ',' : '') + 'A'; }
				}
			}
		}
		//retVal += '&in=' + this.FormEntities.StartYear.value + '-' + this.FormEntities.StartMonth.value + '-' + this.FormEntities.StartDay.value;
		retVal += '&in=' + startDate.getFullYear() + '-' + (startDate.getMonth() + 1) + '-' + startDate.getDate();
		retVal += '&out=' + endDate.getFullYear() + '-' + (endDate.getMonth() + 1) + '-' + endDate.getDate();
		retVal += '&coupon=';
		if(this.FormEntities.PromoCode != null) { retVal += encodeURIComponent(this.FormEntities.PromoCode.value); }

		return retVal;
	},
	RoundNumber: function(value, decimals) {
		var dec = Math.pow(10, decimals);
		var rounded = Math.round(value * dec) / dec;
		return rounded;
	},
	SearchPageBooking : function() {
		var url = '';
		if(this.Parameters.UseBookingInPage || (this.Parameters.UseMobile() && !this.Parameters.UseResponsive)) {
			url = this.GenerateBookingUrl(this.Parameters.Addresses.PageBookUrl);
		}
		if((this.Parameters.UseNewBooking && !this.Parameters.UseMobile()) || (this.Parameters.UseNewBooking && this.Parameters.UseMobile() && this.Parameters.UseResponsive)) {
			url = this.GenerateNewBookingUrl(this.Parameters.Addresses.NewBookingUrl);
		}
		if(sbSearch.Parameters.UseGoogleAnalyticsIntegration) { 
			var SBPageTracker = GetGATracker(this.Parameters.GAPageTrackerName);
			if(SBPageTracker) {
				//try{ var gaUrl = SBPageTracker._getLinkerUrl(url); this.GoToBooking(gaUrl); }
				try{ var gaUrl = GetGALinkerUrl(SBPageTracker, url); this.GoToBooking(gaUrl); }
				catch(e) { this.GoToBooking(url); }
			} else {
				this.GoToBooking(url);
			}
		} else {
			this.GoToBooking(url);
		}
	},
	GoToBooking: function(url) { 
		if(!this.Parameters.OpenInNewWindow) { top.location.href = url; }
		else { window.open(url); }
	},
	SearchWindow : function() {
		var self = this;
		var wndPram = 'scrollbars=no,resizable=yes,location=no,menubar=no,status=yes,width=630,height=400';
		if(this.WindowForm != null) { if(!this.WindowForm.closed) { this.WindowForm.close(); } }
		var Name = new String('OnlineBooking_' + this.GetSelectedGuid());
		var re = /-/g;
		this.WindowForm = window.open('', Name.replace(re, ''), wndPram);
		if(this.WindowForm != null)
		{
			try { this.CreateFormWindow(); }
			catch(ex) { 
				if(!this.WindowForm.closed) { this.WindowForm.close(); }
				this.WindowForm = window.open('', Name.replace(re, ''), wndPram);
				this.CreateFormWindow();
			}
			var url = this.GenerateBookingUrl(this.Parameters.Addresses.BookUrl);
			url += "&DO=SEARCH";
			var timer = setTimeout(function() { self.SubmitForm(url) }, 500);
		}
	},

	CreateFormWindow : function() {
		this.WindowForm.id = this.WindowForm.name;
		this.WindowForm.document.open();
		this.WindowForm.document.write('Loading...');
		this.WindowForm.document.close();
	},
	SubmitForm : function(url) {
		if(!sbSearch.FormChecked) { sbSearch.ShowErrConfig(); return; }
		sbSearch.CheckSelectedDates();
		sbSearch.FormEntities.SearchForm.target = sbSearch.WindowForm.name;
		sbSearch.FormEntities.SearchForm.action = url;
		if(sbSearch.Parameters.UseGoogleAnalyticsIntegration) { 
			var SBPageTracker = GetGATracker(sbSearch.Parameters.GAPageTrackerName);
			if(SBPageTracker) {
				//try { SBPageTracker._linkByPost(sbSearch.FormEntities.SearchForm); }
				try {
					GetGALinkerForm(SBPageTracker, sbSearch.FormEntities.SearchForm);
				}
				catch(e) { }
			}
		}
		sbSearch.FormEntities.SearchForm.submit();
	},
	
	SetDateCallBack : function(hiddenDateFieldId, tDay, tMonth, tYear) {
		var iDay = parseInt(tDay, 10);
		var iMonth = parseInt(tMonth, 10);
		var iYear = parseInt(tYear, 10);
		if(hiddenDateFieldId == sbSearch.Parameters.HiddenStartDateId)
			sbSearch.SetDaysValues('0', iDay, iMonth, iYear);
		else if(hiddenDateFieldId == sbSearch.Parameters.HiddenEndDateId)
			sbSearch.SetDaysValues('1', iDay, iMonth, iYear);
	},

	GetElementPosition : function (elemID) {
		var offsetTrail = document.getElementById(elemID);
		var offsetLeft = 0;
		var offsetTop = 0;
		while (offsetTrail) {
			offsetLeft += offsetTrail.offsetLeft;
			offsetTop += offsetTrail.offsetTop;
			offsetTrail = offsetTrail.offsetParent;
		}
		if (navigator.userAgent.indexOf('Mac') != -1 && typeof document.body.leftMargin != 'undefined'){
			offsetLeft += document.body.leftMargin;
			offsetTop += document.body.topMargin;
		}
		return { left : offsetLeft, top : offsetTop };
	}
};

window.callNotice = sbSearch.SetDateCallBack;

sbSearch.Ready();

var openSB = {
	Open : function (Lang, Type, OptionalGuid) {
		var Guid = sbSearch.GetSelectedGuid();
		if(OptionalGuid != null) { Guid = OptionalGuid; }
		if(Guid != null && Guid != '')
		{
		    if((sbSearch.Parameters.UseBookingInPage || sbSearch.Parameters.UseNewBooking) && !Type) {
		        var url = sbSearch.Parameters.Addresses.PageBookUrl + '?GUID=' + sbSearch.GetSelectedGuid() + '&LANG=' + sbSearch.Parameters.CodLang;
		        if(sbSearch.Parameters.UseNewBooking)
		            url = sbSearch.Parameters.Addresses.NewBookingUrl + '?hid=' +  sbSearch.Parameters.HotelId + '&lang=' + sbSearch.Parameters.CodLang;

				if(sbSearch.Parameters.UseGoogleAnalyticsIntegration) { 
					var SBPageTracker = GetGATracker(sbSearch.Parameters.GAPageTrackerName);
					if(SBPageTracker) {
						//try{ url = SBPageTracker._getLinkerUrl(url); }
						try{ url = GetGALinkerUrl(SBPageTracker, url); }
						catch(e) {}
					}
				}

				self.location.href = url;
				return;
			}
			var wndParams = 'scrollbars=no,resizable=yes,location=no,menubar=no,status=no,width=630,height=400';
			var Url = 'https://www.simplebooking.it/booking.aspx';
			Url += '?GUID=' + Guid;
			Url += '&LANG=' + ((Lang != null && Lang != '') ? Lang : ((sbSearch.Parameters.CodLang) ? sbSearch.Parameters.CodLang : 'EN'));
			if(Type != null) { Url += '&DO=' + Type; }

			if(sbSearch.Parameters.UseGoogleAnalyticsIntegration) { 
				var SBPageTracker = GetGATracker(sbSearch.Parameters.GAPageTrackerName);
				if(SBPageTracker) {
					//try{ Url = SBPageTracker._getLinkerUrl(Url); }
					try{ Url = GetGALinkerUrl(SBPageTracker, Url); }
					catch(e) {}
				}
			}

			window.open(Url, 'OnlineBooking', wndParams);
		}
		else { alert('Please specify a valid GUID.'); }
	},
	OpenVerisignSeal : function() {
		//var wndParams = 'scrollbars=no,resizable=yes,location=no,menubar=no,status=no,width=550,height=470';
		//var url = 'https://sealinfo.verisign.com/splash?form_file=fdf/splash.fdf&dn=WWW.SIMPLEBOOKING.IT&lang=' + ((sbSearch.Parameters.CodLang) ? sbSearch.Parameters.CodLang.toLowerCase() : 'en');
		//window.open(url, 'OpenVerisignSeal', wndParams);
	}
};

function GetGATracker(trackerName) {
	var tracker = null;
	try{ tracker = eval(trackerName); } catch(e) {}
	// Must be checked with new version of GA
	if(!tracker && window.ga && window.ga.getByName){
	    tracker = ga.getByName(trackerName);
	    if (!tracker) {
	        tracker = ga.getByName("t0");
	    }
	}
	if(!tracker && window._gaq && window._gaq._getAsyncTracker) {
		try { tracker = _gaq._getAsyncTracker(); } catch(e) {}
	}
	return tracker;
}
function GetGALinkerUrl(tracker, url){
	if(tracker._getLinkerUrl) {
		return tracker._getLinkerUrl(url);
	} 
	if(tracker.get) {
		var linker = new window.gaplugins.Linker(tracker);
		return linker.decorate(url);
	}
	return url;
}
function GetGALinkerForm(tracker, form){
	if(tracker._linkByPost) {
		tracker._linkByPost(form);
	} 
	if(tracker.get) {
		form.action = GetGALinkerUrl(tracker, form.action);
	}
}

// Cross browser way to listen for events.
function addListener(element, type, callback) {
	if (element.addEventListener) {
		element.addEventListener(type, callback);
	}
	else if (element.attachEvent) {
		element.attachEvent('on' + type, callback);
	}
}

this.Open = openSB.Open;
this.OpenVerisignSeal = openSB.OpenVerisignSeal;
this.sbSearch = sbSearch;

return this;
})();

function OpenSimpleBooking(Lang, Type, OptionalGuid) {
	openSB.Open(Lang, Type, OptionalGuid);
}

function OpenVerisignSeal() {
	openSB.OpenVerisignSeal();
}
